# Chipquarium
A CHIP-8 fish tank simulator.

Your mission is to keep your pet fish alive as long as possible. To do so, you
will need to:
* Make sure the tank is kept clean.
* Make sure your fish never too hungry.
* Make sure your fish is happy.

If your fish is healthy and happy enough, he will eventually grow larger. But be
sure your fish gets enough sleep! He will refuse to eat and play if he is too
tired.

Chipquarium was programmed using [Octo][1] assembly language as part of
[Octo-ber Jam III][2].

## Controls

### Browser
Press the `V` key to feed your fish.

Press the `4` key to clean the tank.

Press the `R` key to have your fish sleep.

Press the `C` key to play rock-paper-scissors with your fish.

Press the `F` key to view your fish's stats.

During the rock-paper-scissors minigame:

Press the `2` key to cycle up through the options.

Press the `S` key to cycle down through the options.

### COSMAC VIP
Press the `F` key to feed your fish.

Press the `C` key to clean the tank.

Press the `D` key to have your fish sleep.

Press the `B` key to play rock-paper-scissors with your fish.

Press the `E` key to view your fish's stats.

During the rock-paper-scissors minigame:

Press the `2` key to cycle up through the options.

Press the `8` key to cycle down through the options.

## Notes
Chipquarium was written using the original CHIP-8 instruction set. As a result,
it should run on the [COSMAC VIP][3] without any issues.

[1]: http://github.com/JohnEarnest/Octo "JohnEarnest / Octo"
[2]: http://www.awfuljams.com/octojam-iii/ "Octo-ber Jam III"
[3]: http://en.wikipedia.org/wiki/COSMAC_VIP "COSMAC VIP"
